#ifndef CGS_CRWL_H
#define CGS_CRW_H 1

#include "cgi-search.h"
#include <stdio.h>

/*
*  Charsets
*  Longest charset name supported by iconv is 22 bytes.
*  Longest charset name used on web is 15 bytes.
*/
#define CGS_CHARSET_SIZ 24
enum { CGS_CHARSET_MAX = CGS_CHARSET_SIZ - 1 };

/*  URLs  */
struct urlentr {
	char url[CGS_PATH_SIZ];
	char title[CGS_PATH_SIZ];
	char charset[CGS_CHARSET_SIZ];
	unsigned short num;
	unsigned short redir;
	unsigned short stat;
	unsigned short type;
};

/*
*  Content-Types
*  These are all text, except for Pdf and Other
*/
enum { \
	CGS_TYP_TXT,
	CGS_TYP_HTML,
	CGS_TYP_ROBOTS,
	CGS_TYP_SITEMAP,
	CGS_TYP_PDF,
	CGS_TYP_OTHER
};

char typtxts[7][8] = {
	"Text",
	"Html",
	"Robots",
	"SiteMap",
	"Pdf",
	"Other",
	""
};

/*  Sitemap tags. Start from tags in cgi-index.h Max 0x40000000  */
#define CGS_TAG_LOC      0x40000	/*  <loc>          */
#define CGS_TAG_SITEMAP  0x80000	/*  <sitemap>      */
#define CGS_TAG_STMPIDX 0x100000	/*  <sitemapindex  */
#define CGS_TAG_URL     0x200000	/*  <url>          */
#define CGS_TAG_URLSET  0x400000	/*  <urlset        */
/*  Loc or Sitemap  */
enum { CGS_TAG_LOSI = CGS_TAG_LOC | CGS_TAG_SITEMAP };
/*  Loc or Url  */
enum { CGS_TAG_LOUR = CGS_TAG_LOC | CGS_TAG_URL };
/*  Sitemap or Url  */
enum { CGS_TAG_SIUR = CGS_TAG_SITEMAP | CGS_TAG_URL };

/*  Title  */
struct titlprps {
	char str[CGS_PATH_SIZ];
	int len;
};

/*  Method://Host/  */
#define CGS_MHOST_SIZ 272
enum { CGS_MHOST_MAX = CGS_MHOST_SIZ - 1};
enum { CGS_MHOST_MAX2 = CGS_MHOST_MAX - 1};

/*  Stuff for libcurl  */
#define CGS_PDF_SIZ 256
enum { CGS_PDF_MAX = CGS_PDF_SIZ - 1};
/*  Evrything about current URL  */
struct urlprps {
	char base[CGS_PATH_SIZ];	/*  Base URL  */
	char line[CGS_BUF_SIZ];
	char line2[CGS_BUF_SIZ];
	char line3[CGS_BUF_SIZ];
	char mhost[CGS_MHOST_SIZ];	/*  Method://Host/  */
	char pdfnam[CGS_PDF_SIZ];	/*  PDF name  */
	int *chrcnt;			/*  Keeps track of longest word  */
	int cont;			/*  Continue when not zero  */
	int crawl;			/*  Follow links if 1, else just index  */
	int docnt;
	int linecnt;
	int mode;			/*  Head, Get, etc  */
        int outp;
	int tags;
	struct titlprps title;
	FILE *pdfil;			/*  PDF file  */
};

/*  Ref URL  */
struct refurl {
	char url[CGS_MHOST_SIZ];
	int len;
};

/*  External URL  */
struct exturl {
	char url[CGS_PATH_SIZ];
};

/*  More libcurl stuff  */
#define CGS_USER_AGENT   "SputNlBot http://www.sput.nl/bot.html"
#define CGS_CURL_CON_TIM 8L
#define CGS_CURL_TIMEOUT 20L
#define CGS_CURL_BUF_SIZ 4096L

/*  PDF to Text  */
#define CGS_PDF_TO_TEXT "/usr/bin/pdftotext"
#define CGS_COM_SIZ 256
enum { CGS_COM_MAX = CGS_COM_SIZ - 1 };

/*  Declarations  */
int fndbasurl(char *url, char *base, char *mhost);
int growurlst(void);
int growextnlst(void);
int fromutf(char *inbuf, int inlen, char *outbuf, int outsiz, char *charset);
int prepget(struct urlprps *urlprops);
int procharset(char *charset);
int procpath(char *mhost, char *base, char *link);

#endif	/*  cgi-crawl.h  */

