#ifndef CGS_INDX_H
#define CGS_INDX_H 1

#include "sgent2utf.h"
#include <stdio.h>
#include "wc2str.h"
#include <wchar.h>
#include <wctype.h>

/*  Use HTML extensions other then '.html' */
//#define CGS_MULT_HTML_EXT 1

#ifdef CGS_MULT_HTML_EXT
 /*  Edit this if you want to use other HTML extensions  */
 struct htmlext {
     int  len;		/*  Length of HTML extension  */
     char str[12];	/*  HTML extension  */
 } htmlexts[] = { \
     { 4, ".htm" },
     { 5, ".html" }, 
     { 4, ".php" }, 
     { 6, ".phtml" }, 
     { 6, ".shtml" },
     { 0, "" }		/*  Terminate  */
 };
#endif

/*  Default nr of word array entries */
#define CGS_DFLT_WORD_ENTRS 32768
/*  Default nr of docs  */
#define CGS_DFLT_DOCS 256

#define CGS_DFLT_DAT_SIZ 14	/*  Multiple of 4 minus 2  */
#define CGS_NEXT_DAT_SIZ 32	/*  The first grow  */

/*  UTF-8 multibyte strings  */
enum { CGS_MBS_SIZ = 6 * CGS_WRD_SIZ } ;
enum { CGS_MBS_MAX = CGS_MBS_SIZ - 1} ;
/*  Note: Later things are checked for CGS_WRD_MAX  */

/*  2 smaller then CGS_WRD_SIZ  */
enum { CGS_WRD_MAX2 = CGS_WRD_MAX - 1 } ;

/*  One smaller then minimum word length. Should be at least one  */
#define CGS_MIN_WRD_LEN 1

//<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
//<meta
//http-equiv="Content-Type"
//content="
//charset=...">

/*  Stuff for remtag()  */
#define CGS_TAG_ALT        0x1	/*  alt=" ...   */
#define CGS_TAG_ANCH       0x2	/*  <a ...      */
#define CGS_TAG_AREA       0x4	/*  <area ...   */
#define CGS_TAG_CONT       0x8	/*  content="   */
#define CGS_TAG_EQUIV     0x10	/*  http-equiv="Content-Type"  */
#define CGS_TAG_FRAME     0x20	/*  <frame ...  */
#define CGS_TAG_HEAD      0x40	/*  <head>      */
#define CGS_TAG_HREF      0x80	/*  href=" ...  */
#define CGS_TAG_IFRAME   0x100	/*  <iframe ... */
#define CGS_TAG_META     0x200  /*  <meta ...   */
#define CGS_TAG_NAME     0x400	/*  name=" ...  */
#define CGS_TAG_OTHER    0x800	/*  Any but the other stuff  */
#define CGS_TAG_REMARK  0x1000	/*  <!-- ...    */
#define CGS_TAG_SCRIPT  0x2000	/*  <script     */
#define CGS_TAG_SRC     0x4000	/*  src=" ...   */
#define CGS_TAG_STYLE   0x8000	/*  <style      */
#define CGS_TAG_TITLE  0x10000	/*  <title>     */
#define CGS_TAG_TITLE2 0x20000	/*  title=" ... */

/*  Max remtag output string  */
enum { CGS_REMTAG_OUT_MAX = CGS_BUF_MAX2 - CGS_ENT_SIZ };

/*  Remark, script or style  */
enum { CGS_TAG_RESCST = CGS_TAG_REMARK | CGS_TAG_SCRIPT | CGS_TAG_STYLE };
/*  cont, equiv, or meta  */
enum { CGS_TAG_COEQME = CGS_TAG_CONT | CGS_TAG_EQUIV | CGS_TAG_META };
/*  a or href  */
enum { CGS_TAG_AHREF  = CGS_TAG_ANCH | CGS_TAG_HREF };
/*  alt, name or title  */
enum { CGS_TAG_ALNATIT2 = CGS_TAG_ALT | CGS_TAG_NAME | CGS_TAG_TITLE | \
    CGS_TAG_TITLE2 };
/*  alt, area or href  */
enum { CGS_TAG_ALARHR = CGS_TAG_ALT | CGS_TAG_AREA | CGS_TAG_HREF };
/*  frame, name or src  */
enum { CGS_TAG_FRNASR = CGS_TAG_FRAME | CGS_TAG_NAME | CGS_TAG_SRC };
/*  iframe, src or title2  */
enum { CGS_TAG_IFSRT2 = CGS_TAG_IFRAME | CGS_TAG_SRC | CGS_TAG_TITLE2 };
/*  href or src  */
enum { CGS_TAG_HRSR   = CGS_TAG_HREF | CGS_TAG_SRC };

/*  Tags that aren't converted to space  */
struct nonsptag {
	char tag[8];
	int  len;
	int  pos;
} nonsptags[] = { \
	{ "</a>", 4, 3 },
	{ "</b>", 4, 3 },
	{ "</i>", 4, 3 },
	{ "</u>", 4, 3 },
	{ "<b>",  3, 2 },
	{ "<i>",  3, 2 },
	{ "<u>",  3, 2 },
	{ "", 0, 0 }
};

/*  Per word list of docs  */
struct word2docs {
    unsigned short *docs;	/*  Points to data initialy  */
    unsigned short siz;
    unsigned short next;
    unsigned short data[CGS_DFLT_DAT_SIZ];
};

#endif  /*  cgi-index.h  */

