#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*
*    Finds title in HTML file.
*
*    Copyright (c) 2020 R.J. van der Putten, Leiden, Holland, 
*    rob at sput dot nl.
* 
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License version 3 as
*    published by the Free Software Foundation.
* 
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*/


int main(void)
{
	int i, j, len, titflg;
	char line[4096];

	i = 0;
	j = 0;
	titflg = 0;
	memset(line, 0, 4096);

	while (fgets(line, 4096, stdin)) {
		len = strlen(line) - 1;
		if (line[len] == 10) {
			line[len] = 0;
			len--;
		}
		if(line[0] == 0)
			continue;
		if (line[len] == 13) {
			line[len] = 0;
			len--;
		}
		if(line[0] == 0)
			continue;
		len++;

		i = 0;
		j = 0;
		while (i < len) {
			if (strncasecmp(line + i, "<title>", 7) == 0) {
				if (titflg == 0) {
					/*  Found start of title  */
					titflg = 1;
					j = i + 7;
				} else {
					fprintf(stderr, "Title error\n");
					exit(1);
				}
			} else if (strncasecmp(line + i, "</title>", 8) == 0) {
				if (titflg == 0) {
					fprintf(stderr, "Title error\n");
					exit(1);
				} else {
					/*  Found end of title  */
					line[i] = 0;
					printf("%s\n", line + j);
					titflg = 0;
					break;
				}
			}
			i++;
		}
		if (titflg != 0) {
			/*  Multi line title  */
			if (line[j] != 0) {
				printf("%s", line + j);
				if (line[len - 1] != ' ')
					printf(" ");
			}
		}
	}

	return(0);
}


